package soot.javaToJimple.ppa;

import polyglot.types.TypeObject;

public class PPAIndex {
	private TypeObject typeObject;

	private Object additionalIndex;

	public PPAIndex(TypeObject typeObject) {
		super();
		this.typeObject = typeObject;
	}

	public PPAIndex(TypeObject typeObject, Object additionalIndex) {
		super();
		this.typeObject = typeObject;
		this.additionalIndex = additionalIndex;
	}

	@Override
	public boolean equals(Object obj) {
		boolean equals = false;

		if (obj instanceof PPAIndex) {
			 PPAIndex toCompare = (PPAIndex) obj;
			equals = TypeFactUtil.same(additionalIndex, toCompare.getAdditionalIndex())
					&& TypeFactUtil.same(typeObject, toCompare.getTypeObject());
		}

		return equals;
	}

	public Object getAdditionalIndex() {
		return additionalIndex;
	}

	public TypeObject getTypeObject() {
		return typeObject;
	}

	@Override
	public int hashCode() {
		return (typeObject != null ? typeObject.hashCode() : 0) + (additionalIndex != null ? additionalIndex.hashCode() : 0);
	}

	public void setAdditionalIndex(Object additionalIndex) {
		this.additionalIndex = additionalIndex;
	}

	public void setTypeObject(TypeObject typeObject) {
		this.typeObject = typeObject;
	}

	@Override
	public String toString() {
		return typeObject + " : " + additionalIndex;
	}
}
