package soot.javaToJimple.ppa;

public class UnsafeTuple {
	private PPAIndex index;

	private PPANode unsafeNode;

	public UnsafeTuple(PPAIndex index, PPANode unsafeNode) {

		super();
		if (index == null) {
			System.err.println(index);
		}
		this.index = index;
		this.unsafeNode = unsafeNode;
	}

	@Override
	public boolean equals(Object obj) {
		boolean equals = false;
		if (obj instanceof UnsafeTuple) {
			UnsafeTuple other = (UnsafeTuple) obj;
			try {
				equals = TypeFactUtil.same(index, other.index)
						&& TypeFactUtil.positionEquals(unsafeNode.position(), other.unsafeNode
								.position());
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		return equals;
	}

	public PPAIndex getIndex() {
		return index;
	}

	public PPANode getUnsafeNode() {
		return unsafeNode;
	}

	@Override
	public int hashCode() {
		return index.hashCode() + TypeFactUtil.hashCode(unsafeNode.position());
	}

	public void setIndex(PPAIndex index) {
		this.index = index;
	}

	public void setUnsafeNode(PPANode unsafeNode) {
		this.unsafeNode = unsafeNode;
	}
}
