package soot.javaToJimple.ppa.jj.ast;

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ext.jl.ast.ConstructorCall_c;
import polyglot.types.ClassType;
import polyglot.types.ConstructorInstance;
import polyglot.types.Context;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;

public class PPAConstructorCall_c extends ConstructorCall_c {

	public PPAConstructorCall_c(Position pos, Kind kind, Expr qualifier, List arguments) {
		super(pos, kind, qualifier, arguments);
		// TODO Auto-generated constructor stub
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		try {
			node = super.typeCheck(tc);
		} catch(SemanticException se) {
			Context c = tc.context();
			ClassType ct = c.currentClass();
			List argTypes = new LinkedList();

			for (Iterator iter = this.arguments.iterator(); iter.hasNext();) {
			    Expr e = (Expr) iter.next();
			    argTypes.add(e.type());
			}
			
			ConstructorInstance ci = tc.typeSystem().findConstructor(ct, argTypes, c.currentClass());
			
			
			node = constructorInstance(ci);
		}
		
		return node;
	}
	
	

}
