package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Node;
import polyglot.ast.PackageNode;
import polyglot.ext.jl.ast.Disamb_c;
import polyglot.types.Named;
import polyglot.types.Qualifier;
import polyglot.types.Resolver;
import polyglot.types.SemanticException;

public class PPADisamb_c extends Disamb_c {

	public PPADisamb_c() {
		super();
	}

	@Override
	protected Node disambiguatePackagePrefix(PackageNode pn) throws SemanticException {
		Resolver pc = ts.packageContextResolver(c.outerResolver(), pn.package_());

		// PPA: This is not a final request: this is only a package prefix so it is normal if you
		// can't find it right away.
		Named n = pc.find(name, false);
		Qualifier q = null;

		if (n instanceof Qualifier) {
			q = (Qualifier) n;
		} else {
			return null;
		}

		if (q.isPackage() && packageOK()) {
			return nf.PackageNode(pos, q.toPackage());
		} else if (q.isType() && typeOK()) {
			return nf.CanonicalTypeNode(pos, q.toType());
		} else if (typeOK()) {
			// A fqn type is requested, so create it!
			n = pc.find(name, true);
			q = (Qualifier) n;
			return nf.CanonicalTypeNode(pos, q.toType());
		}

		return null;
	}

	
	
}
