package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ast.TypeNode;
import polyglot.types.Flags;
import polyglot.types.SemanticException;
import polyglot.types.Type;
import polyglot.util.Position;
import polyglot.visit.ExceptionChecker;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.jj.ast.JjFieldDecl_c;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;

public class PPAFieldDecl_c extends JjFieldDecl_c {

	public PPAFieldDecl_c(Position pos, Flags flags, TypeNode type, String name, Expr init) {
		super(pos, flags, type, name, init);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;

		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
		}

		if (!TypeFactUtil.isSafe(init())) {
			Expr initNode = init();
			Type nodeType = type().type();
			Type initType = initNode.type();

			if (TypeFactUtil.isTypeSafer(nodeType, initType)) {
				PPAEngine.v().reportNewFact(
						new TypeFact(TypeFactUtil.getMainIndex(initNode), initType, nodeType,
								TypeFact.CHILD_OR_EQUALS, TypeFact.ASSIGN_STRATEGY, null));
			}
			node = this;
		}

		return node;
	}

	@Override
	public Node exceptionCheck(ExceptionChecker ec) throws SemanticException {
		Node node = null;
		
		try {
			node = super.exceptionCheck(ec);
		} catch(SemanticException se) {
			node = this;
			ec.throwsSet().clear();
		}
		
		return node;
	}
	
	
}
