package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ast.Stmt;
import polyglot.ext.jl.ast.If_c;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;

public class PPAIf_c extends If_c {
	public PPAIf_c(Position pos, Expr cond, Stmt consequent, Stmt alternative) {
		super(pos, cond, consequent, alternative);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		SemanticException sExcep = null;
		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
			sExcep = se;
			node = this;
		}

		if (!TypeFactUtil.isSafe(cond)) {
			PPAEngine.v().reportNewFact(
					new TypeFact(TypeFactUtil.getMainIndex(cond), cond.type(), tc.typeSystem()
							.Boolean(), TypeFact.CHILD_OR_EQUALS,TypeFact.CONDITION_STRATEGY, null));
		} else {
			if (sExcep != null) {
				// throw sExcep;
			}
		}

		return node;
	}
}
