package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ast.TypeNode;
import polyglot.types.Flags;
import polyglot.types.SemanticException;
import polyglot.types.Type;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.jj.ast.JjLocalDecl_c;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;

public class PPALocalDecl_c extends JjLocalDecl_c {
	
	public PPALocalDecl_c(Position pos, Flags flags, TypeNode type, String name, Expr init) {
		super(pos, flags, type, name, init);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		SemanticException se = null;

		try {
			node = super.typeCheck(tc);
		} catch (SemanticException seTemp) {
			se = seTemp;
		}

		// if init is null, there is nothing we can do
		if (init == null) {
			if (se != null) {
				throw se;
			}
		} else {

			boolean leftUnsafe = !TypeFactUtil.isSafe(li);
			boolean rightUnsafe = !TypeFactUtil.isSafe(init);
			Type leftT = li.type();
			Type rightT = init.type();

			if (se != null && ((leftUnsafe && rightUnsafe) || (!leftUnsafe && !rightUnsafe))) {
				throw se;
				// Left can be unsafe but it should never be changed!
				// } else if (leftUnsafe) {
				// PPAEngine.v().reportSafer(
				// new SafeTuple(SafeUtil.getMainIndex(left), leftT, rightT,
				// SafeTuple.SUPER_OR_EQUALS));
			} else if (rightUnsafe) {
				PPAEngine.v().reportNewFact(
						new TypeFact(TypeFactUtil.getMainIndex(init), rightT, leftT,
								TypeFact.CHILD_OR_EQUALS,TypeFact.ASSIGN_STRATEGY, null));
			}

			node = localInstance(li);
		}
		return node;
	}

}
