package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.types.CodeInstance;
import polyglot.types.Context;
import polyglot.types.MethodInstance;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.jj.ast.JjReturn_c;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;

public class PPAReturn_c extends JjReturn_c {

	public PPAReturn_c(Position pos, Expr expr) {
		super(pos, expr);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		SemanticException sExcep = null;

		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
			node = this;
			sExcep = se;
		}

		Context c = tc.context();
		CodeInstance ci = c.currentCode();
		if (ci instanceof MethodInstance) {
			MethodInstance mi = (MethodInstance) ci;
			if (!TypeFactUtil.isSafe(expr)) {
				PPAEngine.v().reportNewFact(
						new TypeFact(TypeFactUtil.getMainIndex(expr), expr.type(), mi.returnType(),
								TypeFact.CHILD_OR_EQUALS,TypeFact.RETURN_STRATEGY, null));
			} else {
				if (sExcep != null) {
					// throw sExcep;
				}
			}

		}

		return node;
	}

}
