package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Node;
import polyglot.ast.TypeNode;
import polyglot.ext.jl.ast.Special_c;
import polyglot.types.ClassType;
import polyglot.types.Context;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;

public class PPASpecial_c extends Special_c {

	public PPASpecial_c(Position pos, Kind kind, TypeNode qualifier) {
		super(pos, kind, qualifier);
		// TODO Auto-generated constructor stub
	}
	
	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;

		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
			Context c = tc.context();

			ClassType t;

			if (qualifier == null) {
				// an unqualified "this" or "super"
				t = c.currentClass();
			} else {
				t = qualifier.type().toClass();
			}

			if (kind == THIS) {
				node = type(t);
			} else if (kind == SUPER) {
				node = type(t.superType());
			} else {
				node = this;
			}
		}

		return node;
	}

}
