package soot.javaToJimple.ppa.jj.ast;

import java.util.List;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ext.jl.ast.Switch_c;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;
import soot.javaToJimple.ppa.jj.types.PPATypeSystem;

public class PPASwitch extends Switch_c {
	public PPASwitch(Position pos, Expr expr, List elements) {
		super(pos, expr, elements);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		SemanticException sExcep = null;
		PPATypeSystem ts = (PPATypeSystem) tc.typeSystem();
		
		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
			sExcep = se;
			node = this;
		}

		if (!TypeFactUtil.isSafe(expr)) {
			// TODO See if it makes sense...
			PPAEngine.v().reportNewFact(
					new TypeFact(TypeFactUtil.getMainIndex(expr), expr.type(), ts.magicInt(),
							TypeFact.CHILD_OR_EQUALS,TypeFact.SWITCH_STRATEGY,null));
		} else {
			if (sExcep != null) {
				// throw sExcep;
			}
		}

		return node;
	}
}
