package soot.javaToJimple.ppa.jj.ast;

import polyglot.ast.Expr;
import polyglot.ast.Node;
import polyglot.ast.Stmt;
import polyglot.ext.jl.ast.While_c;
import polyglot.types.SemanticException;
import polyglot.util.Position;
import polyglot.visit.TypeChecker;
import soot.javaToJimple.ppa.PPAEngine;
import soot.javaToJimple.ppa.TypeFact;
import soot.javaToJimple.ppa.TypeFactUtil;

public class PPAWhile_c extends While_c {
	public PPAWhile_c(Position pos, Expr cond, Stmt body) {
		super(pos, cond, body);
	}

	@Override
	public Node typeCheck(TypeChecker tc) throws SemanticException {
		Node node = null;
		try {
			node = super.typeCheck(tc);
		} catch (SemanticException se) {
			if (TypeFactUtil.isSafe(cond)) {
				throw se;
			} else {
				node = this;
			}
		}

		if (!TypeFactUtil.isSafe(cond)) {
			PPAEngine.v().reportNewFact(
					new TypeFact(TypeFactUtil.getMainIndex(cond), cond.type(), tc.typeSystem()
							.Boolean(), TypeFact.CHILD_OR_EQUALS,TypeFact.CONDITION_STRATEGY,null));
		}

		return node;
	}
}
